#version 430

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 inNormal;
layout(location = 2) in vec2 inTexCoord;

out vec3 Normal;
out vec3 FragPos;
out vec2 texCoord;
out vec4 fragPosLight;

uniform mat4 u_transform;
uniform mat4 u_viewProjection;
uniform mat4 lightViewProjection;

void main()
{
	//matrix multiplication is not commutative
	Normal = mat3(transpose(inverse(u_transform))) * inNormal;
	FragPos = vec3(u_transform * vec4(position, 1.0));
	gl_Position = u_viewProjection * vec4(FragPos, 1.0);
	texCoord = vec2(inTexCoord.x, inTexCoord.y);
	fragPosLight = lightViewProjection * vec4(FragPos, 1.0);
};